Redmine - Patch #17718

Body delimiters to truncate emails do not take uncommon whitespace into account
2014-08-20 18:23 - Holger Just

Status: Closed Start date:

Priority: Normal Due date:

Assignee: % Done: 0%
Category: Email receiving Estimated time: 0.00 hour
Target version: 3.4.0

Description

The function which truncate emails after a certain delimiter was found (i.e. MailHandler#cleanup_body) currently does not take
trailing whitespace into account that is not part of \s. This e.g. includes non-breaking spaces which are common after e.g. signature
delimiters (hyphen hyphen no-break-space).

This results in delimiters being not taken into account if there are these unicode whitespace characters at the end of the line.
The attached patch fixes this for Ruby versions >= 1.9. | have found no generally reliable way to fix this for Ruby 1.8 which thus

retains the previous behavior. The reason this only works on Ruby >= 1.9 is that only this version includes a possibility to match
unicode whitespace. Ruby 1.8 only has a limited list of ASCII characters (against the unicode spec apparently).

Given that | can't change the behavior on 1.8, this change is unfortunately rather difficult to test. | have also attached a patch with
improved tests which work properly on 1.9 and 2.0 but breaks on 1.8 as it doesn't recognize the change in behavior. Given that, I'd
rather prefer to pull the improvement of behavior without the test than to hold everything out...

Associated revisions

Revision 16609 - 2017-06-06 03:34 - Toshi MARUYAMA

allow unicode whitespace after mail handler body delimiters (#17718)

Contributed by Holger Just and Marius BALTEANU.

History

#1 - 2014-08-20 18:29 - Jan Niggemann (redmine.org team member)

- Tracker changed from Defect to Patch

Thank you, Holger!

#2 - 2014-09-18 05:36 - Toshi MARUYAMA

- Target version set to 2.6.0

#3 - 2014-09-18 05:38 - Toshi MARUYAMA

- Target version changed from 2.6.0 to Candidate for next major release
#4 - 2016-12-25 19:00 - Go MAEDA
Current versions of Redmine don't support Ruby 1.8 (#14371).

| think the rebased version of the patch can be merged into Redmine core.

#5 - 2017-05-07 21:46 - Marius BALTEANU
- File 0001-Allow-unicode-whitespace-after-mail-handler-body-del _r16545.patch added

Updated Holger Just first patch to apply cleanly.

#6 - 2017-05-08 13:16 - Go MAEDA

- Target version changed from Candidate for next major release to 3.4.0

Thank you for fixing the patch. Now we can apply 0001-Allow-unicode-whitespace-after-mail-handler-body-del_r16545.patch and

0002-Add-test-for-trailing-unicode-whitespace-after-email.patch to the current trunk.
Setting target version to 3.4.0.
http://stackoverflow.com/a/4981864
https://www.redmine.org/issues/14371
https://www.redmine.org/attachments/18253
https://www.redmine.org/attachments/12267

#7 - 2017-06-06 07:18 - Toshi MARUYAMA

- Status changed from New to Closed

Committed in trunk, thanks.

Files

0001-Allow-unicode-whitespace-after-mail-handler-body-del.patch 1.02 KB
0002-Add-test-for-trailing-unicode-whitespace-after-email.patch 1.82 KB
0001-Allow-unicode-whitespace-after-mail-handler-body-del_r16545 pa3cBytes
